package com.muchinfo.mtp3pojos.exportconverter;

import com.alibaba.excel.converters.Converter;
import com.alibaba.excel.enums.CellDataTypeEnum;
import com.alibaba.excel.metadata.GlobalConfiguration;
import com.alibaba.excel.metadata.data.ReadCellData;
import com.alibaba.excel.metadata.data.WriteCellData;
import com.alibaba.excel.metadata.property.ExcelContentProperty;

public class TradeTypeConverter implements Converter<Integer> {

    private static final String TYPE_1 = "正常委托成交";
    private static final String TYPE_2 = "定向做市成交(接单)";
    private static final String TYPE_3 = "交收协议平仓成交";
    private static final String TYPE_4 = "交收减仓成交";
    private static final String TYPE_5 = "到期强平成交";
    private static final String TYPE_6 = "风控斩仓成交";
    private static final String TYPE_7 = "协议平仓(管理端)成交";
    private static final String TYPE_8 = "仓单转持仓成交";
    private static final String TYPE_9 = "交收协议转让成交";
    private static final String TYPE_10 = "受托竞价成交(接单)";
    private static final String TYPE_11 = "协议转让成交";
    private static final String TYPE_12 = "管理端强平成交";
    private static final String TYPE_13 = "违约平仓成交";
    private static final String TYPE_14 = "场外期权单向成交";
    private static final String TYPE_15 = "冻结头寸解冻申请";
    private static final String TYPE_16 = "冻结头寸商品配售";
    private static final String TYPE_17 = "冻结头寸商品转让";
    private static final String TYPE_18 = "冻结头寸商品回购";
    private static final String TYPE_19 = "冻结头寸商品提货";
    private static final String TYPE_20 = "冻结头寸结算解冻";
    private static final String TYPE_21 = "转换外部商品";

    @Override
    public Class<?> supportJavaTypeKey() {
        // 实体类中对象属性类型
        return Integer.class;
    }

    @Override
    public CellDataTypeEnum supportExcelTypeKey() {
        // Excel中对应的CellData属性类型
        return CellDataTypeEnum.STRING;
    }

    @Override
    public Integer convertToJavaData(ReadCellData<?> cellData, ExcelContentProperty contentProperty, GlobalConfiguration globalConfiguration) throws Exception {
        // 从Cell中读取数据
        String gender = cellData.getStringValue();
        // 判断Excel中的值，将其转换为预期的数值
        if (TYPE_1.equals(gender)) {
            return 1;
        } else if (TYPE_2.equals(gender)) {
            return 2;
        } else if (TYPE_3.equals(gender)) {
            return 3;
        } else if (TYPE_4.equals(gender)) {
            return 4;
        } else if (TYPE_5.equals(gender)) {
            return 5;
        } else if (TYPE_6.equals(gender)) {
            return 6;
        } else if (TYPE_7.equals(gender)) {
            return 7;
        } else if (TYPE_8.equals(gender)) {
            return 8;
        } else if (TYPE_9.equals(gender)) {
            return 9;
        } else if (TYPE_10.equals(gender)) {
            return 10;
        } else if (TYPE_11.equals(gender)) {
            return 11;
        } else if (TYPE_12.equals(gender)) {
            return 12;
        } else if (TYPE_13.equals(gender)) {
            return 13;
        } else if (TYPE_14.equals(gender)) {
            return 14;
        } else if (TYPE_15.equals(gender)) {
            return 15;
        } else if (TYPE_16.equals(gender)) {
            return 16;
        } else if (TYPE_17.equals(gender)) {
            return 17;
        } else if (TYPE_18.equals(gender)) {
            return 18;
        } else if (TYPE_19.equals(gender)) {
            return 19;
        } else if (TYPE_20.equals(gender)) {
            return 20;
        } else if (TYPE_21.equals(gender)) {
            return 21;
        }
        return null;
    }

    @Override
    public WriteCellData<?> convertToExcelData(Integer integer, ExcelContentProperty contentProperty, GlobalConfiguration globalConfiguration) throws Exception {
        // 判断实体类中获取的值，转换为Excel预期的值，并封装为CellData对象
        if (integer == null) {
            return new WriteCellData<>("");
        } else if (integer == 1) {
            return new WriteCellData<>(TYPE_1);
        } else if (integer == 2) {
            return new WriteCellData<>(TYPE_2);
        } else if (integer == 3) {
            return new WriteCellData<>(TYPE_3);
        } else if (integer == 4) {
            return new WriteCellData<>(TYPE_4);
        } else if (integer == 5) {
            return new WriteCellData<>(TYPE_5);
        } else if (integer == 6) {
            return new WriteCellData<>(TYPE_6);
        } else if (integer == 7) {
            return new WriteCellData<>(TYPE_7);
        } else if (integer == 8) {
            return new WriteCellData<>(TYPE_8);
        } else if (integer == 9) {
            return new WriteCellData<>(TYPE_9);
        } else if (integer == 10) {
            return new WriteCellData<>(TYPE_10);
        } else if (integer == 11) {
            return new WriteCellData<>(TYPE_11);
        } else if (integer == 12) {
            return new WriteCellData<>(TYPE_12);
        } else if (integer == 13) {
            return new WriteCellData<>(TYPE_13);
        } else if (integer == 14) {
            return new WriteCellData<>(TYPE_14);
        } else if (integer == 15) {
            return new WriteCellData<>(TYPE_15);
        } else if (integer == 16) {
            return new WriteCellData<>(TYPE_16);
        } else if (integer == 17) {
            return new WriteCellData<>(TYPE_17);
        } else if (integer == 18) {
            return new WriteCellData<>(TYPE_18);
        } else if (integer == 19) {
            return new WriteCellData<>(TYPE_19);
        } else if (integer == 20) {
            return new WriteCellData<>(TYPE_20);
        } else if (integer == 21) {
            return new WriteCellData<>(TYPE_21);
        }
        return new WriteCellData<>("");
    }
}
